﻿/*!
\file:main.cpp
\author LiuJuan
\Date 2020/11/09
*/

#include <QApplication>
#include <QLibraryInfo> // 国际化
#include <QTranslator>	// 国际化
#include <iostream>
#include "dialog.h"
#include "qglobal.h"

using std::cout;
using std::endl;

int main(int argc, char * argv[]) {
	Q_UNUSED(argc);
	Q_UNUSED(argv);
	QApplication app(argc, argv);

	// 国际化
	// 安装qt自带的中文翻译
	const QString localSysName = QLocale::system().name();
	QScopedPointer<QTranslator> qtTranslator(new QTranslator(QCoreApplication::instance()));
	if (qtTranslator->load(QStringLiteral("qt_") + localSysName,
		QLibraryInfo::location(QLibraryInfo::TranslationsPath)))
	{
		QCoreApplication::installTranslator(qtTranslator.take());
	}

	// 安装该项目的翻译文件		
	QString strPath = "../../system/lang";	// 获取qm文件所在的路径		/system/lang/xxxxx.qm
	QScopedPointer<QTranslator> gpTranslator(new QTranslator(QCoreApplication::instance()));
	if (gpTranslator->load("ui_01.qm", strPath))
	{
		QCoreApplication::installTranslator(gpTranslator.take());
	}

	CDialog dlg(NULL);
	dlg.exec();
   
	return 0;
}
