﻿/*!
* Copyright (C) 2018 女儿叫老白
* 版权所有。
* 代码仅用于课程《C++老鸟日记》的学习，请勿传播。
* 免责声明:代码不保证稳定性，请勿用作商业用途，否则后果自负。

\file: ks07_06_struct.h
\brief  通信数据帧结构定义
\author 女儿叫老白，代表作《Qt 5/PyQt 5实战指南》，微信公众号:软件特攻队(微信号:xingdianketang) 
\Date 2020/12
* please import ks07_06_dll.dll
*/
#pragma once

#include "customtype.h"

#include "ks07_06_dll_export.h"


#include "prealign.h"
// 帧头结构体
struct KS07_06_DLL_API KS07_06_FrameHeader {
    KS07_06_FrameHeader();
    type_uint8	byStart;			// 同步字, 0x68
    type_uint8	byFrameType;		// 帧类型
    void NetToHost();       		// 网络序转到主机序
    void HostToNet();       		// 主机序转到网络序
} DISALIGN;
// 模拟量数据结构体
struct KS07_06_DLL_API KS07_06_AnalogData {
    KS07_06_AnalogData();
    type_uint32 uDataId;            // 数据项Id, 从0开始
    type_double dValue;             // 数据的值
    void NetToHost();       		// 网络序转到主机序
    void HostToNet();       		// 主机序转到网络序
} DISALIGN;

// 客户端-设置数据命令结构体
struct KS07_06_DLL_API KS07_06_Client_SetData {
    KS07_06_Client_SetData();
    KS07_06_FrameHeader	header; 	// 帧头
    KS07_06_AnalogData data;        // 模拟量数据
    void NetToHost();       		// 网络序转到主机序
    void HostToNet();       		// 主机序转到网络序
} DISALIGN;

// 客户端-获取数据命令结构体
struct KS07_06_DLL_API KS07_06_Client_GetData {
    KS07_06_Client_GetData();
    KS07_06_FrameHeader	header; 	// 帧头
    type_uint32 uDataId;            // 数据项Id, 从0开始
    void NetToHost();       		// 网络序转到主机序
    void HostToNet();       		// 主机序转到网络序
} DISALIGN;

// 服务器端-单个模拟量数结构体
struct KS07_06_DLL_API KS07_06_Server_OneAnalogData {
    KS07_06_Server_OneAnalogData();
    KS07_06_FrameHeader	header; 	// 帧头
    KS07_06_AnalogData data;        // 模拟量数据
    void NetToHost();       		// 网络序转到主机序
    void HostToNet();       		// 主机序转到网络序
} DISALIGN;

// 服务器端-批量模拟量数结构体
struct KS07_06_DLL_API KS07_06_Server_AnalogDatas {
    KS07_06_Server_AnalogDatas();
    KS07_06_FrameHeader	header; 	// 帧头
    type_uint32 u32StartDataId;     // 起始数据序号
    type_uint32 u32CurrentFrameDataCount;// 本帧数据个数
    void NetToHost();       		// 网络序转到主机序
    void HostToNet();       		// 主机序转到网络序
} DISALIGN;

#include "postalign.h"
