﻿/*!
* Copyright (C) 2018 女儿叫老白
* 版权所有。
* 代码仅用于课程《C++老鸟日记》的学习，请勿传播。
* 免责声明:代码不保证稳定性，请勿用作商业用途，否则后果自负。

\file: host_to_network.h
\brief 通用dll接口定义头文件, 该DLL不依赖Qt。
\author 女儿叫老白，代表作《Qt 5/PyQt 5实战指南》，微信公众号:软件特攻队(微信号:xingdianketang) 
\Date 2018/10
* please import basedll.dll
*/

#pragma once

#include "base_export.h"
#include "customtype.h"

namespace ns_train {
//  字节序转换 网络序到主机
BASE_API
void
NetworkToHost(void* Data,			// 输入需要转换的数据，输出转换后的数据
	type_uint16 DataLen);			// 输入需要转换数据长度

// type_uint8字节序转换(单字节本无需转换，提供此函数是为了简化编程)
BASE_API
type_uint8
NetworkToHost(type_uint8 Data);		// 输入需要转换的数据，输出转换后的数据

// type_uint16字节序转换
BASE_API
type_uint16
NetworkToHost(type_uint16 Data);	// 输入需要转换的数据，输出转换后的数据

// type_int16字节序转换
BASE_API
type_int16
NetworkToHost(type_int16 Data);		// 输入需要转换的数据，输出转换后的数据

// type_uint32字节序转换
BASE_API
type_uint32
NetworkToHost(type_uint32 Data);	// 输入需要转换的数据，输出转换后的数据

// type_int32字节序转换
BASE_API
type_int32
NetworkToHost(type_int32 Data);		// 输入需要转换的数据，输出转换后的数据

// type_float 字节序转换
BASE_API
type_float
NetworkToHost(type_float Data);		// 输入需要转换的数据，输出转换后的数据

// type_double 字节序转换
BASE_API
type_double
NetworkToHost(type_double Data);	// 输入需要转换的数据，输出转换后的数据

// type_time_t 字节序转换
BASE_API
type_time_t
NetworkToHost(type_time_t Data);	// 输入需要转换的数据，输出转换后的数据


////////////////////////////////////////////////////////////////////////////////////
// 字节序转换 主机到网络序
BASE_API
void
HostToNetwork(void* Data,			// 输入需要转换的数据，输出转换后的数据
	type_uint16 DataLen);			// 输入需要转换数据长度

// type_uint8字节序转换(单字节本无需转换，提供此函数是为了简化编程)
BASE_API
type_uint8
HostToNetwork(type_uint8 Data);		// 输入需要转换的数据，输出转换后的数据

// type_uint16字节序转换
BASE_API
type_uint16
HostToNetwork(type_uint16 Data);	// 输入需要转换的数据，输出转换后的数据

// type_int16字节序转换
BASE_API
type_int16
HostToNetwork(type_int16 Data);		// 输入需要转换的数据，输出转换后的数据

// type_uint32字节序转换
BASE_API
type_uint32
HostToNetwork(type_uint32 Data);	// 输入需要转换的数据，输出转换后的数据

// type_int32字节序转换
BASE_API
type_int32
HostToNetwork(type_int32 Data);		// 输入需要转换的数据，输出转换后的数据

// type_float 字节序转换
BASE_API
type_float
HostToNetwork(type_float Data);		// 输入需要转换的数据，输出转换后的数据

// type_double 字节序转换
BASE_API
type_double
HostToNetwork(type_double Data);	// 输入需要转换的数据，输出转换后的数据


// type_time_t 字节序转换
BASE_API
type_time_t
HostToNetwork(type_time_t Data);	// 输入需要转换的数据，输出转换后的数据

////////////////////////////////////////////////////////////////////////////////////
// 字节拼接、拆分
// 获取type_uint16的低字节
BASE_API
type_uint8
LowByte(type_uint16 data);

// 获取type_uint16的高字节
BASE_API
type_uint8
HighByte(type_uint16 data);

// 获取type_uint32的低字
BASE_API
type_uint16
LowWord(type_uint32 data);

// 获取type_uint32的高字
BASE_API
type_uint16
HighWord(type_uint32 data);

// 将2个 type_uint8 拼成1个 type_uint16
BASE_API
type_uint16
MakeWord(type_uint8 bylobyte, type_uint8 byhibyte);

// 将2个 type_uint16 拼成1个 type_uint32
BASE_API
type_uint32
MakeDWord(type_uint16 wloword, type_uint16 whiword);

/**
* @brief 将4个 type_uint8 拼成1个 type_uint32
*        拼接后的数据： 0x byte0 byte1  byte2 byte3
* @param[in] byte0 最高位字节
* @param[in] byte1 中间字节
* @param[in] byte2 中间字节
* @param[in] byte3 最低位字节
* @return void
*/
BASE_API
type_uint32
MakeDWord(type_uint8 byte0, type_uint8 byte1, type_uint8 byte2, type_uint8 byte3);

};
