﻿/*!
* Copyright (C) 2020 女儿叫老白
* 版权所有。
* 代码仅用于课程《C++老鸟日记》的学习，请勿传播。
* 免责声明:代码不保证稳定性，请勿用作商业用途，否则后果自负。
\file: api_windows.cpp
\brief 示例文件
\author 女儿叫老白，代表作《Qt 5/PyQt 5实战指南》，微信公众号:软件特攻队(微信号:xingdianketang) 
\Date 2020/2
*/

#include "service_api.h"
#include <windows.h>
#include <time.h>
#include "service_windows.h"
#include "base_api.h"
#include "base_class.h"
namespace ns_train {
int api_start_as_service(const char* service_name, const char* service_showname) {
	if (start_service(service_name, service_showname)) {
		return 0;
	}
	else {
		return -1;
	}
}
void api_sleep(int nMSecond) {
	if (nMSecond < 0)
		nMSecond = 0;
	Sleep(nMSecond);
}


void api_ignore_signal(void) {
}

CPPMutex g_mutexTime;
type_time_t get_current_time() {
    g_mutexTime.lock();
    type_time_t tmNow = time(NULL);
    g_mutexTime.unlock();
    return tmNow;
}
STimeGapMS get_current_time_ms() {
    STimeGapMS tIntervalTime;
    SYSTEMTIME tSystemTime;
    struct tm atm;
    //获取系统时间(带毫秒)
    GetLocalTime(&tSystemTime);
    atm.tm_year = tSystemTime.wYear - 1900;     // tm_year以 1900 年为基准
    atm.tm_mon = tSystemTime.wMonth - 1;        // tm_mon 从 0 开始计数
    atm.tm_mday = tSystemTime.wDay;
    atm.tm_hour = tSystemTime.wHour;
    atm.tm_min = tSystemTime.wMinute;
    atm.tm_sec = tSystemTime.wSecond;
    atm.tm_isdst = 0;
    g_mutexTime.lock();
    tIntervalTime.nSecond = static_cast<type_uint32>(mktime(&atm));
    g_mutexTime.unlock();
    tIntervalTime.nMSecond = tSystemTime.wMilliseconds;
    return tIntervalTime;
}
void api_setCPU(int cpuId) {
    //指定倒数第一个（最后一个核）作为绑定核
    HANDLE pThreadHandle = GetCurrentThread();
    DWORD cpuMask = 0x1;
    if (cpuId > 0)
        cpuMask = cpuMask << cpuId;
    SetThreadAffinityMask(pThreadHandle, cpuMask);
}
}
