﻿/*!
* Copyright (C) 2018 女儿叫老白
* 版权所有。
* 代码仅用于课程《C++老鸟日记》的学习，请勿传播。
* 免责声明:代码不保证稳定性，请勿用作商业用途，否则后果自负。

\file: mutex_linux.cpp
\brief 跨平台互斥类 linux 平台实现
\author 女儿叫老白，代表作《Qt 5/PyQt 5实战指南》，微信公众号:软件特攻队(微信号:xingdianketang) 
\Date 2018/9
*/

#include "base_class.h"
#include <pthread.h>

namespace ns_train {
struct SMutexData {
	pthread_mutex_t m_mutex;
};

CPPMutex::CPPMutex() {
	pthread_mutexattr_t tMutexAttr;

    m_pMutexData = new SMutexData;

	pthread_mutexattr_init(&tMutexAttr);

	pthread_mutexattr_settype(&tMutexAttr, PTHREAD_MUTEX_RECURSIVE);
    pthread_mutex_init(&m_pMutexData->m_mutex, &tMutexAttr);

	pthread_mutexattr_destroy(&tMutexAttr);
}

CPPMutex::~CPPMutex() {
    pthread_mutex_destroy(&m_pMutexData->m_mutex);
    delete m_pMutexData;
}

type_bool CPPMutex::tryLock() {
    return (pthread_mutex_trylock(&m_pMutexData->m_mutex) == 0);
}

void CPPMutex::lock() {
    pthread_mutex_lock(&m_pMutexData->m_mutex);
}

void CPPMutex::unlock() {
    pthread_mutex_unlock(&m_pMutexData->m_mutex);
}
}
