﻿/*!
* Copyright (C) 2018 女儿叫老白
* 版权所有。
* 代码仅用于课程《C++老鸟日记》的学习，请勿传播。
* 免责声明:代码不保证稳定性，请勿用作商业用途，否则后果自负。

\file: check_sum.cpp
\brief 校验接口实现文件
\author 女儿叫老白，代表作《Qt 5/PyQt 5实战指南》，微信公众号:软件特攻队(微信号:xingdianketang) 
\Date 2020/12
* please import comnunicate.dll
*/
#pragma once
#include "check_sum.h"

static bool bchInited = false;
static type_uint8	TBCH[256];						// BCH 校验表 G(X)=107H

void initBCH();
// 返回 BCH 校验码
type_uint8 getBCH(type_uint8* pDataBuf, type_uint32 nCount) {
	type_uint8	byReturnValue = 0;
	initBCH();
	for (type_uint32 i = 0; i < nCount; i ++ ) {
		byReturnValue = byReturnValue^pDataBuf[i];
		byReturnValue = TBCH[byReturnValue];
	}
	byReturnValue = byReturnValue^0xFF;
	return byReturnValue;
}

// BCH 表初始化
void initBCH() {
	if (!bchInited) {
		bchInited = true;
		type_uint8	byTemp;
		for (int i = 0; i < 256; i++) {
			byTemp = i;
			for (int j = 0; j < 8; j++) {
				if (byTemp & 0x80)	{
					byTemp = byTemp << 1;
					byTemp = byTemp ^ 0x7;
				}
				else {
					byTemp = byTemp << 1;
				}
			}
			TBCH[i] = byTemp;
		}
	}
}