﻿/*!
* Copyright (C) 2018 女儿叫老白
* 版权所有。
* 代码仅用于课程《C++老鸟日记》的学习，请勿传播。
* 免责声明:代码不保证稳定性，请勿用作商业用途，否则后果自负。

\file: com_serial.h
\brief 串口通讯类实现文件。
\author 女儿叫老白，代表作《Qt 5/PyQt 5实战指南》，微信公众号:软件特攻队(微信号:xingdianketang) 
\Date 2018/10
*/

#include "com_serial.h"
#ifdef WIN32
#include "com_serialproxy_windows.h"
#else
#include "com_serialproxy_linux.h"
#endif
/////////////////////////////////////////////////////////////////////////
namespace ns_train {
s_serial_config::s_serial_config() {
	u32Baudrate = 1200; 
	byDatabits = 8;
	chStopbit = 1;
	chParity = 'N';
	memset(strDevicename, 0, sizeof(strDevicename) / sizeof(type_char));
}

/////////////////////////////////////////////////////////////////////////
CPPSerial::CPPSerial(const s_serial_config& config) : m_pData(new CSerialProxy(config)){
}

CPPSerial::~CPPSerial() {
	if (NULL != m_pData) {
		delete m_pData;
		m_pData = NULL;
	}
}

bool CPPSerial::open() {
	if (NULL != m_pData) {
		return m_pData->open();
	}
	return false;
}
bool CPPSerial::isOpen() {
	if (NULL != m_pData) {
		return m_pData->isOpen();
	}
	return false;
}
bool CPPSerial::close() {
	if (NULL != m_pData) {
		return m_pData->close();
	}
	return false;
}

//## 从串口中接收数据
int CPPSerial::read(char* data, int count) {
	if (NULL != m_pData) {
		return m_pData->readData(data, count);
	}
	return 0;
}

//## 发送数据
int CPPSerial::write(char* data, int count) {
	if (NULL != m_pData) {
		return m_pData->writeData(data, count);
	}
	return 0;
}

bool CPPSerial::setSerialConfig(const s_serial_config& config) {
	if (NULL != m_pData) {
		return m_pData->setSerialConfig(config);
	}
	return false;
}

bool CPPSerial::setBaudrate(type_uint16 baudrate) {
	if (NULL != m_pData) {
		return m_pData->setBaudrate(baudrate);
	}
	return false;
}
type_uint16 CPPSerial::getBaudrate() {
	if (NULL != m_pData) {
		return m_pData->getBaudrate();
	}
	return 0;
}

}
