﻿/*! 
* Copyright (C) 2018 女儿叫老白
* 版权所有。
* 代码仅用于课程《C++老鸟日记》的学习，请勿传播。
* 免责声明:代码不保证稳定性，请勿用作商业用途，否则后果自负。

\file: comdata.cpp
\brief	
\author 女儿叫老白，代表作《Qt 5/PyQt 5实战指南》，微信公众号:软件特攻队(微信号:xingdianketang) 
\Date 2018/9 
*/

#include "ks07_07_struct.h"

#include <string.h>

#include "host_network_api.h"
//////////////////////////////////////////////////////////
ks07_07_FrameHeader::ks07_07_FrameHeader()  {
    byStart = 0;			// 同步字, 0x68
    byFrameType = 0;		// 帧类型
}

void ks07_07_FrameHeader::HostToNet()  {
    // 目前都是单字节变量，无需处理。
    // byStart;			// 同步字, 0x68
    // byFrameType;		// 帧类型
}

void ks07_07_FrameHeader::NetToHost()  {
    HostToNet();       	// 主机序转到网络序
}

//////////////////////////////////////////////////////////
ks07_07_AnalogData::ks07_07_AnalogData()  {
    uDataId = 0;		// 数据项Id
    dValue = 0.;		// 数据的值
}

void ks07_07_AnalogData::HostToNet()  {
    uDataId = ns_train::HostToNetwork(uDataId);
    dValue = ns_train::HostToNetwork(dValue);
}

void ks07_07_AnalogData::NetToHost()  {
    HostToNet();       		// 主机序转到网络序
}

//////////////////////////////////////////////////////////
ks07_07_Client_SetData::ks07_07_Client_SetData()  {
}

void ks07_07_Client_SetData::HostToNet()  {
    header.HostToNet();
    data.HostToNet();
}

void ks07_07_Client_SetData::NetToHost()  {
    HostToNet();       		// 主机序转到网络序
}
//////////////////////////////////////////////////////////
ks07_07_Client_GetData::ks07_07_Client_GetData()  {
    uDataId = 0;		// 数据项Id
}

void ks07_07_Client_GetData::HostToNet()  {
    header.HostToNet();
    uDataId = ns_train::HostToNetwork(uDataId);
}

void ks07_07_Client_GetData::NetToHost()  {
    HostToNet();       		// 主机序转到网络序
}

//////////////////////////////////////////////////////////
ks07_07_Server_OneAnalogData::ks07_07_Server_OneAnalogData()  {
}

void ks07_07_Server_OneAnalogData::HostToNet()  {
    header.HostToNet();
    data.HostToNet();
}

void ks07_07_Server_OneAnalogData::NetToHost()  {
    HostToNet();       		// 主机序转到网络序
}

//////////////////////////////////////////////////////////
ks07_07_Server_AnalogDatas::ks07_07_Server_AnalogDatas()  {
    u32StartDataId = 0;
    u32CurrentFrameDataCount = 0;
}

void ks07_07_Server_AnalogDatas::HostToNet()  {
    header.HostToNet();
    u32StartDataId = ns_train::HostToNetwork(u32StartDataId);
    u32CurrentFrameDataCount = ns_train::HostToNetwork(u32CurrentFrameDataCount);
}

void ks07_07_Server_AnalogDatas::NetToHost()  {
    HostToNet();       		// 主机序转到网络序
}
