﻿/*! 
* Copyright (C) 2018 女儿叫老白
* 版权所有。
* 代码仅用于课程《C++老鸟日记》的学习，请勿传播。
* 免责声明:代码不保证稳定性，请勿用作商业用途，否则后果自负。

\file: comdata.cpp
\brief	
\author 女儿叫老白，代表作《Qt 5/PyQt 5实战指南》，微信公众号:软件特攻队(微信号:xingdianketang) 
\Date 2018/9 
*/

#include "ksui_01_struct.h"

#include <string.h>

#include "check_sum.h"
#include "host_network_api.h"
//////////////////////////////////////////////////////////
ksui_01_FrameHeader::ksui_01_FrameHeader()  {
    byStart = 0;			// 同步字, 0x68
    byFrameType = 0;		// 帧类型
    n32FrameIndex = -1;     // 帧序号
}

void ksui_01_FrameHeader::HostToNet()  {
    // byStart;			// 同步字, 0x68
    // byFrameType;		// 帧类型
    n32FrameIndex = ns_train::HostToNetwork(n32FrameIndex);
}

void ksui_01_FrameHeader::NetToHost()  {
    HostToNet();       	// 主机序转到网络序
}

//////////////////////////////////////////////////////////
ksui_01_Client_Ack::ksui_01_Client_Ack()  {
    n32FrameIndexAck = -1;
    checkSum = 0;
}

type_uint8 ksui_01_Client_Ack::calculateChecksum() {
    // 计算校验码
    type_uint8 byCheckSum = getBCH(&header.byFrameType, sizeof(ksui_01_Client_Ack) - sizeof(header.byStart));
    return byCheckSum;
}

void ksui_01_Client_Ack::HostToNet()  {
    header.HostToNet();
    n32FrameIndexAck = ns_train::HostToNetwork(n32FrameIndexAck);
}

void ksui_01_Client_Ack::NetToHost()  {
    HostToNet();       	// 主机序转到网络序
}

//////////////////////////////////////////////////////////
ksui_01_AnalogData::ksui_01_AnalogData()  {
    uDataId = 0;		// 数据项Id
    dValue = 0.;		// 数据的值
}

void ksui_01_AnalogData::HostToNet()  {
    uDataId = ns_train::HostToNetwork(uDataId);
    dValue = ns_train::HostToNetwork(dValue);
}

void ksui_01_AnalogData::NetToHost()  {
    HostToNet();       		// 主机序转到网络序
}

//////////////////////////////////////////////////////////
ksui_01_Client_SetData::ksui_01_Client_SetData()  {
}

void ksui_01_Client_SetData::HostToNet()  {
    header.HostToNet();
    data.HostToNet();
}

void ksui_01_Client_SetData::NetToHost()  {
    HostToNet();       		// 主机序转到网络序
}

type_uint8 ksui_01_Client_SetData::calculateChecksum() {
    // 计算校验码
    type_uint8 byCheckSum = getBCH(&header.byFrameType, sizeof(ksui_01_Client_SetData)-sizeof(header.byStart)-sizeof(checkSum));
    return byCheckSum;
}

//////////////////////////////////////////////////////////
ksui_01_Client_GetData::ksui_01_Client_GetData()  {
    uDataId = 0;		// 数据项Id
}

void ksui_01_Client_GetData::HostToNet()  {
    header.HostToNet();
    uDataId = ns_train::HostToNetwork(uDataId);
}

void ksui_01_Client_GetData::NetToHost()  {
    HostToNet();       		// 主机序转到网络序
}

type_uint8 ksui_01_Client_GetData::calculateChecksum() {
    // 计算校验码
    type_uint8 byCheckSum = getBCH(&header.byFrameType, sizeof(ksui_01_Client_GetData) - sizeof(header.byStart));
    return byCheckSum;
}

//////////////////////////////////////////////////////////
ksui_01_Server_OneAnalogData::ksui_01_Server_OneAnalogData()  {
}

void ksui_01_Server_OneAnalogData::HostToNet()  {
    header.HostToNet();
    data.HostToNet();
}

void ksui_01_Server_OneAnalogData::NetToHost()  {
    HostToNet();       		// 主机序转到网络序
}
type_uint8 ksui_01_Server_OneAnalogData::calculateChecksum() {
    // 计算校验码
    type_uint8 byCheckSum = 0;
    byCheckSum = getBCH(&header.byFrameType, sizeof(ksui_01_Server_OneAnalogData) - sizeof(header.byStart) - sizeof(byCheckSum));
    return byCheckSum;
}

//////////////////////////////////////////////////////////
ksui_01_Server_AnalogDatas::ksui_01_Server_AnalogDatas()  {
    u32StartDataId = 0;
    u32CurrentFrameDataCount = 0;
}

void ksui_01_Server_AnalogDatas::HostToNet()  {
    header.HostToNet();
    u32StartDataId = ns_train::HostToNetwork(u32StartDataId);
    u32CurrentFrameDataCount = ns_train::HostToNetwork(u32CurrentFrameDataCount);
}

void ksui_01_Server_AnalogDatas::NetToHost()  {
    HostToNet();       		// 主机序转到网络序
}

type_uint8 ksui_01_Server_AnalogDatas::calculateChecksum(type_int32 nFrameLength) {
    // 计算校验码
    type_uint8 byCheckSum = 0;
    type_int32 nDataLength = nFrameLength - sizeof(header.byStart) - sizeof(byCheckSum);
    byCheckSum = getBCH(&header.byFrameType, nDataLength);
    return byCheckSum;
}
type_uint8 ksui_01_Server_AnalogDatas::getCheckSum(type_int32 nFrameLength) {
    // 获取本帧数据中的校验码
    type_uint8 byCheckSum = 0;
    type_int32 nDataLength = nFrameLength - sizeof(header.byStart) - sizeof(byCheckSum);
    byCheckSum = *(&header.byFrameType + nDataLength);
    return byCheckSum;
}
//////////////////////////////////////////////////////////
ksui_01_Client_GetFile::ksui_01_Client_GetFile()  {
}

void ksui_01_Client_GetFile::HostToNet()  {
    header.HostToNet();
}
void ksui_01_Client_GetFile::NetToHost()  {
    HostToNet();       		// 主机序转到网络序
}
type_uint8 ksui_01_Client_GetFile::calculateChecksum() {
    // 计算校验码
    type_uint8 byCheckSum = getBCH(&header.byFrameType, sizeof(ksui_01_Client_GetFile) - sizeof(header.byStart));
    return byCheckSum;
}
//////////////////////////////////////////////////////////
ksui_01_Server_File::ksui_01_Server_File()  {
    u32FrameLength = 0;
    byLastFrame = 0;        // 是否最后一帧
    u64Offset = 0;          // 本帧数据在文件中的起始偏移量
    u32DataLength = 0;      // 本帧文件内容长度
}

void ksui_01_Server_File::HostToNet()  {
    header.HostToNet();
    u32FrameLength = ns_train::HostToNetwork(u32FrameLength);
    ns_train::HostToNetwork(&u64Offset, sizeof(u64Offset));
    u32DataLength = ns_train::HostToNetwork(u32DataLength);
}

void ksui_01_Server_File::NetToHost()  {
    HostToNet();       		// 主机序转到网络序
}
type_uint8 ksui_01_Server_File::calculateChecksum(type_int32 nFrameLength) {
    // 计算校验码
    type_uint8 byCheckSum = 0;
    type_int32 nDataLength = nFrameLength - sizeof(header.byFrameType) - sizeof(byCheckSum);
    byCheckSum = getBCH(&header.byFrameType, nDataLength);
    return byCheckSum;
}

type_uint8 ksui_01_Server_File::getCheckSum(type_int32 nFrameLength) {
    // 获取本帧数据中的校验码
    type_uint8 byCheckSum = 0;
    type_int32 nDataLength = nFrameLength - sizeof(header.byFrameType) - sizeof(byCheckSum);
    byCheckSum = *(&header.byFrameType + nDataLength);
    return byCheckSum;
}
