#PROJECT_HOME=../../..
PROJECT_HOME=$$(PROJECT_DEV_HOME)
include ($$PROJECT_HOME/src/project_base.pri)

TEMPLATE	= lib
LANGUAGE	= C++

CONFIG		+= dll

TEMPDIR		= $$PROJECT_OBJ_PATH/base/basedll

DESTDIR     = $$PROJECT_LIB_PATH
DLLDESTDIR  = $$PROJECT_BIN_PATH

INCLUDEPATH += $$PROJECT_HOME/include/base/basedll

win32{
	DEFINES -= UNICODE
	DEFINES *= __BASEDLL_SOURCE__ 
}

HEADERS		+= $$PROJECT_HOME/src/project_base.pri \
				basedll.pro \
				$$PROJECT_HOME/include/base/basedll/service_api.h \
				$$PROJECT_HOME/include/base/basedll/base_api.h \
				$$PROJECT_HOME/include/base/basedll/base_class.h \
				$$PROJECT_HOME/include/base/basedll/host_network_api.h \
				$$PROJECT_HOME/include/base/basedll/base_file.h \
                $$PROJECT_HOME/include/base/basedll/base_ini.h \
                $$PROJECT_HOME/include/base/basedll/base_filehead.h


SOURCES += api.cpp \
            event.cpp \
            file.cpp \
            filehead.cpp \
			host_network_api.cpp \
            ini.cpp \
            mutexlocker.cpp \
            time.cpp 


win32{
	LIBS += -lUser32
	HEADERS	+= service_windows.h

	SOURCES	+= api_windows.cpp \
			   service_windows.cpp \
               lib_windows.cpp \
               thread_windows.cpp \
               mutex_windows.cpp \

}
unix{
    LIBS += -lpthread -ldl
	SOURCES	+= api_linux.cpp \
                lib_linux.cpp \
                thread_linux.cpp \
                mutex_linux.cpp
}

OBJECTS_DIR = $$TEMPDIR
MOC_DIR		= $$TEMPDIR/moc
UI_DIR		= $$TEMPDIR/ui

debug_and_release {
    CONFIG(debug, debug|release) {
		   
		TARGET = basedll_d
	}
	CONFIG(release, debug|release) {			   
				   
		TARGET	= basedll
	}
} else {
	debug {				  
				   
		TARGET	= basedll_d
	}
	release {				  
				   
		TARGET 	= basedll
	}
}
