﻿/*!
* Copyright (C) 2018 女儿叫老白
* 版权所有。
* 代码仅用于课程《C++老鸟日记》的学习，请勿传播。
* 免责声明:代码不保证稳定性，请勿用作商业用途，否则后果自负。

\file: filehead.cpp
\brief 文件头类定义, 该DLL不依赖Qt。
\author 女儿叫老白，代表作《Qt 5/PyQt 5实战指南》，微信公众号:软件特攻队(微信号:xingdianketang) 
\Date 2020/02
*/

#include "base_filehead.h"
#include "base_file.h"
#include "serialize.h"

namespace ns_train {

CPPFile& operator<<(CPPFile& file, const CFileHead& fileHead) {
    file << fileHead.getMainVersion();
    file << fileHead.getSubVersion();
    return file;
}

CPPFile& operator>>(CPPFile& file, CFileHead& fileHead) {
    type_uint16 uMainVersion = 0;
    type_uint16 uSubVersion = 0;
    file >> uMainVersion ;
    file >> uSubVersion ;
    fileHead.setMainVersion(uMainVersion);
    fileHead.setSubVersion(uSubVersion);
    return file;
}

ESerializeCode readFileHeadFromBinary(const std::string& fileName, CFileHead& fileHead) {
    ESerializeCode code = ESERIALIZECODE_OK;
    CPPFile file(fileName.c_str());
    if (file.open("r")) {
        file >> fileHead;
        file.close();
    }
    else {
        code = ESERIALIZECODE_FILENOTFOND;
    }
    return code;
}

}

