﻿/*!
* Copyright (C) 2018 女儿叫老白
* 版权所有。
* 代码仅用于课程《C++老鸟日记》的学习，请勿传播。
* 免责声明:代码不保证稳定性，请勿用作商业用途，否则后果自负。

\file: lib_linux.cpp
\brief 通用dll接口实现文件, 该DLL不依赖Qt。
\author 女儿叫老白，代表作《Qt 5/PyQt 5实战指南》，微信公众号:软件特攻队(微信号:xingdianketang) 
\Date 2020/02
*/

#include "base_class.h"
#include <dlfcn.h>

namespace ns_train {
	struct CLibraryData {
		void* hDll;
	};

	CLibrary::CLibrary() {
		m_pLibraryData = new CLibraryData;
		m_pLibraryData->hDll = NULL;
	}

	CLibrary::~CLibrary() {
		delete m_pLibraryData;
	}

	bool CLibrary::open(const char* pszDLLName) {
		if (pszDLLName == NULL) {
			return false;
		}

		m_strDLLName = "lib";
		m_strDLLName += pszDLLName;
		m_strDLLName += ".so.1";

		m_pLibraryData->hDll = dlopen(m_strDLLName.c_str(), RTLD_LAZY);
		return (m_pLibraryData->hDll != NULL);
	}

	bool CLibrary::close() {
		if (!dlclose(m_pLibraryData->hDll)) {
			return false;
		}
		return true;
	}

	void* CLibrary::getFunction(const char* pszFunctionName) {
		return dlsym(m_pLibraryData->hDll, pszFunctionName);
	}

}
