﻿/*!
* Copyright (C) 2018 女儿叫老白
* 版权所有。
* 代码仅用于课程《C++老鸟日记》的学习，请勿传播。
* 免责声明:代码不保证稳定性，请勿用作商业用途，否则后果自负。

\file: mutex_windows.cpp
\brief 跨平台互斥类 windows 平台实现
\author 女儿叫老白，代表作《Qt 5/PyQt 5实战指南》，微信公众号:软件特攻队(微信号:xingdianketang) 
\Date 2018/9
*/
#include "base_class.h"
#include <windows.h>

namespace ns_train {
struct SMutexData {
    CRITICAL_SECTION m_nMutex;		// 临界区对象
};

CPPMutex::CPPMutex() {
    m_pMutexData = new SMutexData;	// 申请私有结构内存
    // 初始化临界区对象
    InitializeCriticalSection(&m_pMutexData->m_nMutex);
}

CPPMutex::~CPPMutex() {
    // 删除临界区对象
    DeleteCriticalSection(&m_pMutexData->m_nMutex);
    delete m_pMutexData;		// 释放私有结构内存
}

type_bool CPPMutex::tryLock() {
    // 试试进入临界区
    if (TryEnterCriticalSection(&m_pMutexData->m_nMutex))
		return true;

	return false;
}

void CPPMutex::lock() {
    // 进入临界区
    EnterCriticalSection(&m_pMutexData->m_nMutex);
}

void CPPMutex::unlock() {
    // 退出临界区
    LeaveCriticalSection(&m_pMutexData->m_nMutex);
}
}
