﻿/*!
* Copyright (C) 2020 女儿叫老白
* 版权所有。
* 代码仅用于课程《C++老鸟日记》的学习，请勿传播。
* 免责声明:代码不保证稳定性，请勿用作商业用途，否则后果自负。
\file: mutexlocker.cpp
\brief 自动锁的实现文件
\author 女儿叫老白，代表作《Qt 5/PyQt 5实战指南》，微信公众号:软件特攻队(微信号:xingdianketang) 
\Date 2020/2
*/

#include  "base_class.h"
#include  "service_api.h"

namespace ns_train {
CPPMutexLocker::CPPMutexLocker(CPPMutex* pMutex, type_bool bLock) {
    m_pMutex = pMutex;
	m_bLocked = false;
    if (bLock) {
        m_pMutex->lock();
		m_bLocked = true;
	}
}

CPPMutexLocker::~CPPMutexLocker() {
	if (m_bLocked)
        m_pMutex->unlock();
}

type_bool CPPMutexLocker::tryLock(type_int32 mseconds) {
    if (m_bLocked) {
        return true;
    }
    if (mseconds < 0) {
        m_pMutex->lock();
        m_bLocked = true;
    }
    else {
        m_bLocked = m_pMutex->tryLock();
        while (!m_bLocked && mseconds > 0) 	{
            api_sleep(10);
            m_bLocked = m_pMutex->tryLock();
            mseconds -= 10;
        }
    }
	return m_bLocked;
}
}
