﻿/*!
* Copyright (C) 2018 女儿叫老白
* 版权所有。
* 代码仅用于课程《C++老鸟日记》的学习，请勿传播。
* 免责声明:代码不保证稳定性，请勿用作商业用途，否则后果自负。

\file: serverthread.h
\brief 服务器端处理线程类定义。
\author 女儿叫老白，代表作《Qt 5/PyQt 5实战指南》，微信公众号:软件特攻队(微信号:xingdianketang) 
\Date 2018/10
*/

#pragma once

#include "base_class.h"

namespace ns_train {
	class CPPSerial;
}

class CServerThread : public ns_train::CPPThread {
public:
    CServerThread();

    /**
    * @brief  线程主循环函数。内部必须采用while(isWorking())作为主循环。
    * @return 无
    */
    virtual void run() override;
private:
    /**
    * @brief  将待发送数据进行组帧并发送
    * @return true:成功，false：失败。当写入串口失败时，将导致返回false。
    */
    bool makeFrameAndSend();
    /**
    * @brief  将待发送数据进行组帧并发送-模拟量数据集合
    * @return true:成功，false：失败。当写入串口失败时，将导致返回false。
    */
    bool makeFrameAndSend_Analogs();
	/**
	* @brief  复位与发送数据相关的变量。
	* @return 无
	*/
	void reset_send();
    /**
    * @brief  释放申请的内存
    * @return 无
    */
    void freeBuffer();
private:
    ns_train::CPPSerial* m_pSerial;
    char *m_pReceiveBuf;                        // 接收缓冲区
    char *m_pSendBuf;                           // 发送缓冲区
    bool m_bSendData;                           // true:有数据等待发送，false：无数据等待发送
    ns_train::CPPTime m_tmLastSendAllData;      // 上次发送全部模拟量数据的时间
};


