﻿/*!
* Copyright (C) 2018 女儿叫老白
* 版权所有。
* 代码仅用于课程《C++老鸟日记》的学习，请勿传播。
* 免责声明:代码不保证稳定性，请勿用作商业用途，否则后果自负。

\file: serverthread.cpp
\brief 服务器端线程类实现。该线程负责处理客户端连接及交互。
\author 女儿叫老白，代表作《Qt 5/PyQt 5实战指南》，微信公众号:软件特攻队(微信号:xingdianketang) 
\Date 2018/10
*/
#include "serverthread.h"
#include "com_serial.h"
#include "base/basedll/service_api.h"
#include "ks07_08/datavector.h"
#include "ks07_08/ks07_08_server_protocolobject.h"

CServerThread::CServerThread() {
	m_pServerProtocolObject = new CServerProtocolObject();
}
void CServerThread::run() {

    CDataVector* pDataVector = CDataVector::instance();
    if (NULL == pDataVector) {
        return;
    }
    if (NULL == getParam()) {
        return;
    }
	ns_train::CPPSerial* pSerial = static_cast<ns_train::CPPSerial*>(getParam()); // 串口通信对象
	if (NULL == pSerial) {
		return;
	}
	m_pServerProtocolObject->setSerialObject(pSerial);
    bool bOpened = false;
    while (isWorking()) {
        ns_train::api_sleep(10); // 睡眠时间不易过长，否则影响后续代码。
        keepAlive();
        bOpened = m_pServerProtocolObject->open(); // 首先打开串口
        if (!bOpened) {
            continue;
        }

		m_pServerProtocolObject->makeFrameAndSend();         // 检查有没有需要发送的命令

		m_pServerProtocolObject->recvAndParseFrame();        // 接收数据、解帧
     }
	 delete m_pServerProtocolObject;
     m_pServerProtocolObject = NULL;
}
