﻿/*!
* Copyright (C) 2018 女儿叫老白
* 版权所有。
* 代码仅用于课程《C++老鸟日记》的学习，请勿传播。
* 免责声明:代码不保证稳定性，请勿用作商业用途，否则后果自负。

\file: autoreplysetting.cpp
\brief 自动回复设置界面实现。
\author 女儿叫老白，代表作《Qt 5/PyQt 5实战指南》，微信公众号:软件特攻队(微信号:xingdianketang) 
\Date 2020/4
*/
#include "autoreplysetting.h"

#include <QStandardItemModel>
#include <QPushButton>

#include "autoreplymodel.h"
#include "delegate.h"

CAutoReplySetting::CAutoReplySetting(QWidget* parent, CAutoReplyModel* pModel) : QDialog(parent), m_pModel(pModel){
	ui.setupUi(this);

	ui.tableView->setModel(m_pModel);
	CDelegate* pDelegate = new CDelegate(this);
	ui.tableView->setItemDelegate(pDelegate);
	ui.tableView->setColumnWidth(0, 40);
	ui.tableView->setColumnWidth(0, 200);
	ui.tableView->horizontalHeader()->setStretchLastSection(true);
	ui.tableView->setAlternatingRowColors(true);
	connect(ui.btnAdd, &QPushButton::clicked, this, &CAutoReplySetting::slot_add);		// 添加一行配置
	connect(ui.btnDelete, &QPushButton::clicked, this, &CAutoReplySetting::slot_delete);// 删除一行配置
	connect(ui.btnExit, &QPushButton::clicked, this, &CAutoReplySetting::slot_exit);	// 退出

}
CAutoReplySetting::~CAutoReplySetting() {

}

void CAutoReplySetting::slot_add() {
	m_pModel->insertRow(1);
}

void CAutoReplySetting::slot_delete() {
	if (ui.tableView->currentIndex().row() >= 0) {
		m_pModel->removeRow(ui.tableView->currentIndex().row());
	}
}

void CAutoReplySetting::slot_exit() {
	accept();
}
