﻿/*!
* Copyright (C) 2018 女儿叫老白
* 版权所有。
* 代码仅用于课程《C++老鸟日记》的学习，请勿传播。
* 免责声明:代码不保证稳定性，请勿用作商业用途，否则后果自负。

\file delegate.cpp
\brief delegate实现文件
\author 女儿叫老白，代表作《Qt 5/PyQt 5实战指南》，微信公众号:软件特攻队(微信号:xingdianketang) 
\Date 2019/1
*/
#include "delegate.h"

#include <QLineEdit>

#include "autoreplymodel.h"


CDelegate::CDelegate(QObject *parent)
    : QStyledItemDelegate(parent) {
}

QWidget *CDelegate::createEditor(QWidget *parent,
    const QStyleOptionViewItem & option ,
    const QModelIndex & index ) const {
	return QStyledItemDelegate::createEditor(parent, option, index);
}

void CDelegate::setEditorData(QWidget *editor,
                                    const QModelIndex &index) const {
	QModelIndex idxParent = index.parent().isValid()
		? index.parent()
		: index;

	QString str = index.model()->data(index, Qt::DisplayRole).toString();
	QLineEdit *pEditor = static_cast<QLineEdit*>(editor);
	pEditor->setText(str);
	return;
	
	
	QStyledItemDelegate::setEditorData(editor, index);	
}

void CDelegate::setModelData(QWidget *editor, QAbstractItemModel *model,
                                   const QModelIndex &index) const {
	QModelIndex idxParent = index.parent().isValid()
		? index.parent()
		: index;

	QStyledItemDelegate::setModelData(editor, model, index);
}

void CDelegate::updateEditorGeometry(QWidget *editor,
    const QStyleOptionViewItem &option, const QModelIndex &/* index */) const {
    editor->setGeometry(option.rect);
}
