﻿/*!
* Copyright (C) 2018 女儿叫老白
* 版权所有。
* 代码仅用于课程《C++老鸟日记》的学习，请勿传播。
* 免责声明:代码不保证稳定性，请勿用作商业用途，否则后果自负。

\file delegate.h
\brief delegate头文件
\author 女儿叫老白，代表作《Qt 5/PyQt 5实战指南》，微信公众号:软件特攻队(微信号:xingdianketang) 
\Date 2019/1
*/
#pragma once

#include <QStyledItemDelegate>

class CDelegate : public QStyledItemDelegate {
    Q_OBJECT

public:
	CDelegate(QObject *parent = 0);

	/**
	* @brief 为指定数据项创建编辑器
	*
	* @param[in|out] parent 待创建编辑器的父窗口
	* @param[in] option 样式选项
	* @param[in] index 数据项序号
	* @return 创建好的编辑器
	*/
	QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option,
                          const QModelIndex &index) const override;

	/**
	* @brief 为指定数据项的编辑器设置值
	*
	* @param[in|out] editor 指定数据项的编辑器
	* @param[in] index 数据项序号
	* @return 无
	*/
	void setEditorData(QWidget *editor, const QModelIndex &index) const override;
	
	/**
	* @brief 从编辑器读取指定数据项的值并设置到模型
	*
	* @param[in|out] editor 指定数据项的编辑器
	* @param[in|out] model 模型
	* @param[in] index 数据项序号
	* @return 无
	*/
	void setModelData(QWidget *editor, QAbstractItemModel *model,
                      const QModelIndex &index) const override;

	/**
	* @brief 更新指定数据项的编辑器尺寸
	*
	* @param[in|out] editor 指定数据项的编辑器
	* @param[in] option 样式选项
	* @param[in] index 数据项序号
	* @return 无
	*/
	void updateEditorGeometry(QWidget *editor,
        const QStyleOptionViewItem &option, const QModelIndex &index) const override;
private:
};
