﻿/*!
* Copyright (C) 2018 女儿叫老白
* 版权所有。
* 代码仅用于课程《C++老鸟日记》的学习，请勿传播。
* 免责声明:代码不保证稳定性，请勿用作商业用途，否则后果自负。

\file: clientthread.cpp
\brief 数据处理线程类实现。该线程负责持续更新数据。
\author 女儿叫老白，代表作《Qt 5/PyQt 5实战指南》，微信公众号:软件特攻队(微信号:xingdianketang) 
\Date 2018/10
*/

#include "clientthread.h"

#include <iostream>
#include <string.h>

#include "com_serial.h"
#include "base/basedll/service_api.h"
#include "ksui_01/datavector.h"
#include "ksui_01/ksui_01_client_protocolobject.h"
#include "ksui_01/protocolcommand.h"

CClientThread::CClientThread() {
	m_pClientProtocolObject = new CClientProtocolObject();
}
void CClientThread::run() {
    /*
    *	|同步字0x68	|   【1个字节】- 字节0
    *	|帧类型		|   【1个字节】- 字节1
    *	|...		|    不同的“帧类型”有不同的帧格式，请查看后续代码
    */

    CDataVector* pDataVector = CDataVector::instance();
    if (NULL == pDataVector) {
        return;
    }
    if (NULL == getParam()) {
        return;
    }
    ns_train::CPPSerial* pSerial = static_cast<ns_train::CPPSerial*>(getParam()); // 串口通信对象
    if (NULL == pSerial) {
        return;
    }
	m_pClientProtocolObject->setSerialObject(pSerial);

    bool bError = false;
    bool bOk = true;
    bool bOpened = false;
    while (isWorking() && bOk) {
        bError = false;
        ns_train::api_sleep(10); // 睡眠时间不易过长，否则影响后续代码。
        keepAlive();
        bOpened = m_pClientProtocolObject->open(); // 首先打开串口
        if (!bOpened) {
            continue;
        }

		m_pClientProtocolObject->makeFrameAndSend();         // 检查有没有需要发送的命令

		m_pClientProtocolObject->recvAndParseFrame();        // 接收数据、解帧
     }
    delete m_pClientProtocolObject;
    m_pClientProtocolObject = NULL;
}
void CClientThread::pushCommand(CCommandInterface* pCommand) {
	m_pClientProtocolObject->pushCommand(pCommand);
}
