﻿/*!
* Copyright (C) 2018 女儿叫老白
* 版权所有。
* 代码仅用于课程《C++老鸟日记》的学习，请勿传播。
* 免责声明:代码不保证稳定性，请勿用作商业用途，否则后果自负。

\file: datathread.cpp
\brief 数据处理线程类实现。该线程负责模拟数据变化。
\author 女儿叫老白，代表作《Qt 5/PyQt 5实战指南》，微信公众号:软件特攻队(微信号:xingdianketang) 
\Date 2018/10
*/
#include "datathread.h"

#include <iostream>
#include <list>

#include "datavector.h"
#include "base/basedll/service_api.h"


CDataThread::CDataThread() {

}
void CDataThread::run() {
    CDataVector *pDataVector = CDataVector::instance();
    if (NULL == pDataVector) {
        return;
    }
    std::list<type_uint32> lstIds;
    int nSize = pDataVector->getDataIds(lstIds);
    std::list<type_uint32>::iterator ite = lstIds.begin();
    type_double dValue = 0.f;
    type_uint32 iTimes = 0;
    while (isWorking()) {
        ns_train::api_sleep(10);
        keepAlive();
        if (iTimes++ % 50) {
            continue;
        }
        for (ite = lstIds.begin(); ite!= lstIds.end(); ite++) {
            dValue = sin(iTimes)+(*ite)%10;
            pDataVector->setData(*ite, dValue);
        }
    }
}

